#ifndef KXSC7_2050_H
#define KXSC7_2050_H

#include <stdio.h>
#include <mraa.hpp>




class KXSC7_2050
{
public:
	KXSC7_2050(mraa_result_t &response, int pin_X = 0, int pin_Y = 1, int pin_Z = 2, double voltage = 3.3, double r = 0.2);
	~KXSC7_2050();
	mraa_result_t setPinNum(int pin_X = 0, int pin_Y = 1, int pin_Z = 2);
	void setCoefficient(double r);
	void getAcceleration(double &acx, double &acy, double &acz);
	void getAccelerationData(double &acx, double &acy, double &acz);
	double voltage2acceleration(double dVolt);
	void setVoltage(double voltage);
	void reset();
	
private:
	mraa::Aio* ax;
	mraa::Aio* ay;
	mraa::Aio* az;


	double _r;

	double last_x, last_y, last_z;
	
	int m_pin_X, m_pin_Y, m_pin_Z;
	double m_voltage;

};





#endif