#ifndef ENC_03R_H
#define ENC_03R_H

#include <stdio.h>
#include <mraa.hpp>




class ENC_03R
{
public:
	ENC_03R(mraa_result_t &response, int pin_X = 0, int pin_Y = 1, double r = 0.2);
	~ENC_03R();
	mraa_result_t setPinNum(int pin_X = 0, int pin_Y = 1);
	void setCoefficient(double r);
	void getAngularVelocity(double &avx, double &avy);
	void getAngularVelocityData(double &avx, double &avy);
	double voltage2angularvelocity(double dVolt, double offset);
	void reset();
	
private:
	mraa::Aio* ax;
	mraa::Aio* ay;


	double _r;

	double last_x, last_y;
	
	int m_pin_X, m_pin_Y;
	double m_offsetX, m_offsetY;

};





#endif