#ifndef LSM9DS0_I2C_H
#define LSM9DS0_I2C_H


#include "LSM9DS0.h"
 

class LSM9DS0_I2C : public LSM9DS0
{
public:
	LSM9DS0_I2C(mraa_result_t &response, mraa::I2c *i2c, i2c_smf *smf, uint8_t AccaMagaddr = LSM9DS0_ADDRESS_ACCELMAG, uint8_t Gyroaddr = LSM9DS0_ADDRESS_GYRO, uint8_t Accscale = 0x03, uint8_t Magnscale = 0x02, uint8_t GyroScale = 0x01, int mx_offset = 420, int my_offset = -455, int mz_offset = -155,  double ar = 0.2, double mr = 0.2, double gr = 0.2);
	~LSM9DS0_I2C();
	
private:
	
	

	void readByte(uint8_t Address, uint8_t Register, uint8_t Nbytes, uint8_t* Data);
	void writeByte(uint8_t Address, uint8_t Register, uint8_t Data);
	

	mraa::I2c *_i2c;
	
};





#endif